#ifndef _UNIT_TEST_PROBABILITIES_H_
#define _UNIT_TEST_PROBABILITIES_H_

#include "test_module_base.h"

#ifndef _NAB_PROBABILITIES_H_
typedef struct integration_params integration_params;
#endif

class UnitTestProbabilities : public TestModuleBase {
  public:
    UnitTestProbabilities() : TestModuleBase() {}
    virtual ~UnitTestProbabilities() {}

    virtual void RunTests();
    virtual void SetTests();
    bool PrintandCheck(integration_params *tparams,
                       double x,
                       double retval,
                       double answer,
                       double tol = 0.00001);
    bool PrintandCheck(integration_params *tparams,
                       std::vector<double> x,
                       double retval,
                       double answer,
                       double tol = 0.00001);

    // Testing of the different things
    bool Integrand12();
    bool Integrand12Fdep();
    bool Integrand12Advanced();
    bool Prob12();
    bool Prob12Fdep();
    bool Prob12Advanced();
};

#endif
